package woven_transfer;

// Start of user code for imports
import java.util.*;
// End of user code

/**
 * AuthenticationManager class definition.
 * Generated by the TouchCORE code generator.
 */
class AuthenticationManager {
    
    private long passwordExpiryDuration;
    private HashMap<User, Password> myCollection;
    
    void changePassword(User a, String newPassword) {
        Password credentials = getCredentials(a);
        credentials.setPassword(newPassword);
    }

    boolean authenticate(User a, Password c) {
        Session currentSession = Session.getCurrentSession();
        Password cred = getCredentials(a);
        boolean validCredential = cred.check(c);
        if (validCredential) {
            currentSession.setCurrentAuthenticated(a);
        }
        if (validCredentials) {
            Date lastChanged = c.getLastChanged();
            long lastChangedTime = lastChanged.getTime();
            Date currentDate = new Date();
            long currentTime = currentDate.getTime();
            if (currentTime - lastChangedTime > passwordExpiryDuration) {
                PasswordExpiredException exception = new PasswordExpiredException();
                throw exception;
            }
        }
        return validCredential;
    }

    void putCredentials(User k, Password a) {
        myCollection.put(k, a);
    }

    boolean credentialsContainsKey(User k) {
        boolean containsKey = myCollection.containsKey(k);
        return containsKey;
    }

    Password getCredentials(User k) {
        Password value = myCollection.get(k);
        return value;
    }

    void removeFromCredentials(User k) {
        myCollection.remove(k);
    }

    Set<User> keySetOfCredentials() {
        Set<User> keySet = myCollection.keySet();
        return keySet;
    }

    Collection<Password> valuesOfCredentials() {
        Collection<Password> values = myCollection.values();
        return values;
    }

    int sizeOfCredentials() {
        int size = myCollection.size();
        return size;
    }

    boolean containsCredentials(Object a) {
        boolean contains = myCollection.contains(a);
        return contains;
    }

    HashMap<User, Password> getCredentials() {
        return this.myCollection;
    }
}
