package ca.mcgill.sel.workflow.samples;

import ca.mcgill.sel.workflow.EndNode;
import ca.mcgill.sel.workflow.LocalContext;
import ca.mcgill.sel.workflow.ParallelExecutionNode;
import ca.mcgill.sel.workflow.StartupNode;
import ca.mcgill.sel.workflow.SynchronizationNode;

public class ParallelSynchronizationWorkflow extends AbstractWorkflowDemo {

    public ParallelSynchronizationWorkflow(LocalContext context) {
        super(context);
    }

    @Override
    public void initNodes() {
        StartupNode startupNode = new StartupNode();
        EndNode endNode = new EndNode();
        
        ParallelExecutionNode parallelNode = new ParallelExecutionNode();
        
        HelloNode hello = new HelloNode("Hello from main path");
        HelloNode hello1 = new HelloNode("Hello from path 1");
        HelloNode hello2 = new HelloNode("Hello from path 2");
        HelloNode helloEnd = new HelloNode("Hello from end path");
        
        SynchronizationNode synchronizedNode = new SynchronizationNode();
        
        startupNode.setNextNode(hello);
        hello.setNextNode(parallelNode);
        
        parallelNode.addNextNode("path1", hello1);
        parallelNode.addNextNode("path2", hello2);
        parallelNode.addNextNode("wont work", synchronizedNode);
        
        hello1.setNextNode("path12", synchronizedNode);
        hello2.setNextNode("path22", synchronizedNode);
        
        synchronizedNode.setNextNode(helloEnd);
        helloEnd.setNextNode(endNode);
        
        workflow.addNode(startupNode);
        workflow.addNode(parallelNode);
        workflow.addNode(hello);
        workflow.addNode(hello1);
        workflow.addNode(hello2);
        workflow.addNode(helloEnd);
        workflow.addNode(synchronizedNode);
        workflow.addNode(endNode);
        
        workflow.addStartupNode(startupNode);
    }

    public static void main(String[] args) {
        LocalContext context = new LocalContext();
        ParallelSynchronizationWorkflow workflow = new ParallelSynchronizationWorkflow(context);
        workflow.executeWorkflow();
    }

}
